#include "Graph.h"
#include <queue>
#include <algorithm>
#include <iostream>
#include <map>
#include <stack>
#include <list>
#pragma warning(disable:4018 4267)


float Complex::m_sThreshold=0.0f;


struct nodeinfo
{
public:
	int   m_iNode;
	float m_fWeight;

public:
	nodeinfo(int iNode, float fWeight) 
	{
		m_iNode = iNode;
		m_fWeight = fWeight;
	}
	
};
	
//#define MYDEBUG


bool GreaterThanByDegree(Node*	lhs,Node* rhs)
{
	if(lhs->m_iDegree>rhs->m_iDegree)
		return true;
	return false;
}

bool LessThanByNumNodes(Clique* lhs, Clique* rhs)
{
	if(lhs->m_iNumNodes < rhs->m_iNumNodes)
		return true;
	return false;
}


bool LessThanByBet(Arc* lhs, Arc* rhs)
{
	if (lhs->m_Bet < rhs->m_Bet)
		return true;
	return false;
}

bool GreaterThanByWeight(Arc* lhs, Arc* rhs)
{
	if (lhs->m_fWeight > rhs->m_fWeight)
		return true;
	return false;
}

Graph::Graph(const char* szFileName)
{
	strcpy(m_szFileName,szFileName);

	m_szFileName[strlen(m_szFileName)-4]='\0';

	m_strFileName=szFileName;

	std::string::size_type	pos=m_strFileName.find('.');
	
	m_strFileName=m_strFileName.substr(0,pos);



	GraphLoader	rawGraph(szFileName);

	LoadGraphFromRawGraph(rawGraph);
	
}


void Graph::LoadGraphFromRawGraph(GraphLoader&	rawGraph)
{
	for(int i=0;i<rawGraph.m_nArcs;i++)								//rawGraphжȡߵϢ
	{
		int j,k;
		bool bFoundFrom=false;
		bool bFoundTo=false;
		for(j=0;j<m_NodeArray.size();j++)					   //鿴ߵʼڵǷڡ j˸ıʼλ
		{
			if(!strcmp(m_NodeArray[j]->m_szName,rawGraph.m_RawGraph[i].m_szFrom))
			{
				bFoundFrom=true;
				break;
			}
			
		}		
		for(k=0;k<m_NodeArray.size();k++)					    //鿴ߵֹڵǷڡ k˸ıʼλ
		{
			if(!strcmp(m_NodeArray[k]->m_szName,rawGraph.m_RawGraph[i].m_szTo))
			{
				bFoundTo=true;
				break;
			}
		}
		if(bFoundFrom==false)									//ڣ򴴽һµĽڵ
		{
			Node* pNode=new Node(m_NodeArray.size(),rawGraph.m_RawGraph[i].m_szFrom);
			m_NodeArray.push_back(pNode);
			j=m_NodeArray.size()-1;												 //j˸ıʼλ
		}
		if(bFoundTo==false)
		{
			Node* pNode=new Node(m_NodeArray.size(),rawGraph.m_RawGraph[i].m_szTo);
			m_NodeArray.push_back(pNode);
			k=m_NodeArray.size()-1;
		}

		m_NodeArray[j]->InsertArc(j,k,rawGraph.m_RawGraph[i].m_fWeight);    //һ
		m_NodeArray[j]->m_iDegree++;
		m_NodeArray[j]->m_iWDegree=m_NodeArray[j]->m_iWDegree+rawGraph.m_RawGraph[i].m_fWeight;
		m_NodeArray[k]->InsertArc(k,j,rawGraph.m_RawGraph[i].m_fWeight);   //һ
		m_NodeArray[k]->m_iDegree++;
        m_NodeArray[k]->m_iWDegree=m_NodeArray[k]->m_iWDegree+rawGraph.m_RawGraph[i].m_fWeight;
		m_NodeArray[j]->m_pFirst->m_pImage = m_NodeArray[k]->m_pFirst;
		m_NodeArray[k]->m_pFirst->m_pImage = m_NodeArray[j]->m_pFirst;
	}
	m_nNumEdges=rawGraph.m_nArcs;
}


void Graph::FilterGraph(int iDegreeThreshold)
{
	int		iDelete=0;
	GraphLoader	tempRawGraph;

	for(size_t i=0;i<m_NodeArray.size();++i)
	{
			m_NodeArray[i]->m_bMarked=false;
	}


	for(size_t i=0;i<m_NodeArray.size();++i)
	{
		if(m_NodeArray[i]->m_iDegree<=iDegreeThreshold)
		{
			iDelete++;
			m_NodeArray[i]->m_bMarked=true;
		}
	}

	for(size_t i=0;i<m_NodeArray.size();++i)
	{
		Node*	pNode=m_NodeArray[i];
		if(pNode->m_bMarked==false)		//ûMarkĽڵı
		{
			Arc*	pArc=pNode->m_pFirst;
			while(pArc!=0)
			{
				if((pNode->m_iNode<pArc->m_iNodeTo)&&(m_NodeArray[pArc->m_iNodeTo]->m_bMarked==false)) //ָڵŴpNode&&ָڵûMarkʱ
				{
					GraphArc arc(pNode->m_szName,m_NodeArray[pArc->m_iNodeTo]->m_szName,0.0f);
					tempRawGraph.m_RawGraph.push_back(arc);
				}
				pArc=pArc->m_pNextArc;
			}
		}
	}

#ifdef MYDEBUG
	std::cout<<"Deleted Nodes was: "<<iDelete<<std::endl;
	std::cout<<"Reversed Nodes was: "<<m_NodeArray.size()-iDelete<<std::endl;
#endif

	tempRawGraph.m_nArcs=tempRawGraph.m_RawGraph.size();
	ClearNodes();
	LoadGraphFromRawGraph(tempRawGraph);

}



void Graph::DumpComplexInfo(const char* szFileName,int iSize)
{
	std::ofstream	OutFile;
	OutFile.open(szFileName);
	if(!OutFile)
	{
		std::cout<<"Can't Create Output File!"<<std::endl;
	}
	
	int Count=0;
	for(int i=0;i<m_ComplexArray.size();i++)
	{
		if(m_ComplexArray[i]->m_iNumNodes>=iSize)
		{
			OutFile<<"Complex "<<Count<<"  "<<m_ComplexArray[i]->m_iNumNodes<<std::endl;
			for(int j=0;j<m_ComplexArray[i]->m_iNumNodes;j++)
			{
				OutFile<<m_NodeArray[m_ComplexArray[i]->m_ComplexNodes[j]]->m_szName<<std::endl;
			}
			Count++;
		}
	}
	OutFile.close();
}


void Graph::ShowGraph()
{
	std::cout<<"=================Graph Infomation====================="<<std::endl;
	
	for (size_t i=0; i<m_NodeArray.size(); ++i)
	{
		std::cout<<"Node "<<i<<" | "<<m_NodeArray[i]->m_szName<<std::endl;
		
		Arc* pArc = m_NodeArray[i]->m_pFirst;
		while(pArc!=NULL)
		{
			std::cout<<"Arc to Node "<<pArc->m_iNodeTo<<" | "<<m_NodeArray[pArc->m_iNodeTo]->m_szName<<std::endl;
			pArc = pArc->m_pNextArc;
		}
		std::cout<<"-------------------------------------------------"<<std::endl;
	}

	std::cout<<"======================================================"<<std::endl;
}	

void Graph::ComputeBetweenness()
{
	//ShowGraph();
	size_t NumNodes=m_NodeArray.size();
	int *distance = new int[NumNodes];
	int *nodeBet = new int[NumNodes];
	float *dependency = new float [NumNodes];

	std::queue<Node*> Q;
	std::stack<Node*> S;
	std::vector<Arc*>* P = new std::vector<Arc*>[NumNodes];
	
	ClearArcBet();

	ClearNodeBet();
	
	for(size_t i=0; i<NumNodes; ++i)
	{

		for(size_t j=0; j<NumNodes; ++j)
		{
			distance[j] = -1;
			nodeBet[j] = 0;
			dependency[j] = 0;
			P[j].clear();
		}
		distance[i] = 0;
		nodeBet[i] = 1;

		Q.push(m_NodeArray[i]);

		while(!Q.empty())
		{
			Node* pNode = Q.front();
			Q.pop();
			S.push(pNode);

			Arc* pArc = pNode->m_pFirst;

			while(pArc!=NULL)
			{
				if (distance[pArc->m_iNodeTo]<0)
				{
					Q.push(m_NodeArray[pArc->m_iNodeTo]);
					distance[pArc->m_iNodeTo] = distance[pNode->m_iNode] + 1;
					nodeBet[pArc->m_iNodeTo] = nodeBet[pNode->m_iNode];
					P[pArc->m_iNodeTo].push_back(pArc);
				}
				else
				{
					if (distance[pArc->m_iNodeTo] == distance[pNode->m_iNode] +1)
					{
						nodeBet[pArc->m_iNodeTo] = nodeBet[pArc->m_iNodeTo] + nodeBet[pNode->m_iNode];
						P[pArc->m_iNodeTo].push_back(pArc);
					}
				}
				pArc = pArc->m_pNextArc;
			}

		}
		
		while(!S.empty())
		{

			Node* pNode = S.top();
			S.pop();
			
			int count=P[pNode->m_iNode].size();
			for(size_t j=0; j<count; ++j)
			{
				Arc* pArc = P[pNode->m_iNode][j];
				int index = pArc->m_iNodeFrom;
				float fWeight = (float)nodeBet[index]/(float)nodeBet[pNode->m_iNode];
				dependency[index] = (dependency[index] + fWeight * (1 + dependency[pNode->m_iNode]));
				pArc->m_Bet += fWeight * (1 + dependency[pNode->m_iNode]);
			}

			if( i != pNode->m_iNode)
			{
				pNode->m_Bet += dependency[pNode->m_iNode];
			}
		}
	}

	
	for (size_t i=0; i<NumNodes; ++i)
	{
		m_NodeArray[i]->m_Bet/=2;
	}

	for(size_t i=0; i<NumNodes; ++i)
	{
		Node* pNode = m_NodeArray[i];
		Arc*  pArc = pNode->m_pFirst;

		while(pArc!=NULL)
		{
			if(pNode->m_iNode<pArc->m_iNodeTo)
			{
				pArc->m_Bet += pArc->m_pImage->m_Bet;
				pArc->m_Bet /=2;
			}
			pArc = pArc->m_pNextArc;
		}
	}

}


void Graph::ComputeArcWeight()
{

	for (size_t i = 0; i<m_NodeArray.size(); ++i)
	{
		Node *pNode = m_NodeArray[i];
		Arc  *pArc = pNode->m_pFirst;

		while (pArc != NULL)
		{
			pNode->m_fTotalWeight += pArc->m_fOriginWeight;
			pArc = pArc->m_pNextArc;
		}
	}

	
	
	
	std::vector<nodeinfo>  adjNodes;

	for (size_t i=0; i<m_NodeArray.size(); ++i)
	{
		adjNodes.clear();
		Node* pNode = m_NodeArray[i];
		Arc*  pArc  = pNode->m_pFirst;

		while(pArc!=NULL)
		{

			adjNodes.push_back(nodeinfo(pArc->m_iNodeTo, pArc->m_fOriginWeight));
			pArc = pArc->m_pNextArc;
		}

		pArc = pNode->m_pFirst;

		while(pArc!=NULL)
		{
			if(pArc->m_iNodeFrom<pArc->m_iNodeTo)
			{

				Node* pAdjNode = m_NodeArray[pArc->m_iNodeTo];
				Arc*  pAdjArc  = pAdjNode->m_pFirst;
				
				float fsum1 = 0.0f;
				float fsum2 = 0.0f;

				while(pAdjArc != NULL)
				{
					int iFound = 0;
					for (iFound = 0; iFound < adjNodes.size(); ++iFound)
					{
						if (pAdjArc->m_iNodeTo == adjNodes[iFound].m_iNode)
						{
							fsum1 += adjNodes[iFound].m_fWeight;
							fsum2 += pArc->m_fOriginWeight;
							break;
						}
					} 
					pAdjArc = pAdjArc->m_pNextArc;
				}

				pArc->m_fWeight = (fsum1 * fsum2) / (pNode->m_fTotalWeight * pAdjNode->m_fTotalWeight);

				pArc->m_pImage->m_fWeight = pArc->m_fWeight;

			}
			pArc = pArc->m_pNextArc;
		}

	}
}

void Graph::GenerateComplexBy(float fThreshold)
{

	ComputeArcWeight();
	
	Complex::m_sThreshold = fThreshold;
	std::vector<Arc*> arcs;
	arcs.reserve(m_nNumEdges);

	for(size_t i=0; i<m_NodeArray.size(); ++i)
	{
		Node* pNode = m_NodeArray[i];
		Arc*  pArc  = pNode->m_pFirst;
		while (pArc != NULL)
		{
			if (pArc->m_iNodeFrom<pArc->m_iNodeTo)
			{
				arcs.push_back(pArc);
			}
			pArc = pArc->m_pNextArc;
		}
	}

	std::stable_sort(arcs.begin(), arcs.end(), GreaterThanByWeight);
	size_t  numArcs = arcs.size();

	std::vector<Complex*> subgraph;
	subgraph.reserve(m_NodeArray.size());
	
	for(size_t i=0; i<m_NodeArray.size(); ++i)
	{

		Complex* pComplex = new Complex(i,this);
		pComplex->m_ComplexNodes.push_back(i);
		pComplex->m_iInDegree = 0;
		pComplex->m_iTotalDegree = m_NodeArray[i]->m_iDegree;
		pComplex->m_iInWDegree = 0;
		pComplex->m_iTotalWDegree = m_NodeArray[i]->m_fTotalWeight;
		pComplex->m_iNumNodes=1;
		subgraph.push_back(pComplex);
		m_NodeArray[i]->m_iComplex = i;

	}

	for(size_t i=0; i<numArcs; ++i)
	{
		Arc* pArc = arcs[i];

		//
		int iFrom = pArc->m_iNodeFrom;
		int iTo   = pArc->m_iNodeTo;

		int iCFrom = m_NodeArray[iFrom]->m_iComplex;
		int iCTo   = m_NodeArray[iTo]->m_iComplex;

		if(iCFrom != iCTo)    //ȾͲ
		{

			if(subgraph[iCFrom]->m_bMergeable==true &&
				subgraph[iCTo]->m_bMergeable==true)
			{
				
				if(subgraph[iCFrom]->m_bModule!=true || subgraph[iCTo]->m_bModule!=true)
				{

					if(subgraph[iCFrom]->m_iNumNodes>=subgraph[iCTo]->m_iNumNodes)
					{
						subgraph[iCFrom]->Merge(subgraph[iCTo]);
						delete subgraph[iCTo];
						subgraph[iCTo]=NULL;
					}
					else
					{
						subgraph[iCTo]->Merge(subgraph[iCFrom]);
						delete subgraph[iCFrom];
						subgraph[iCFrom]=NULL;
					}

				}
				else
				{
					subgraph[iCFrom]->m_bMergeable=false;
					subgraph[iCTo]->m_bMergeable=false;
				}
			}
			else
			{
				subgraph[iCFrom]->m_bMergeable=false;
				subgraph[iCTo]->m_bMergeable=false;
			}

			
		}
	}

	for(int i=0; i<subgraph.size(); ++i)
	{
		if (subgraph[i] != NULL)
		{
			m_ComplexArray.push_back(subgraph[i]);
		}
	}

}
void Complex::Merge(Complex* pComplex)
{

	m_iInDegree += pComplex->m_iInDegree;
	m_iTotalDegree += pComplex->m_iTotalDegree;
	m_iInWDegree += pComplex->m_iInWDegree;
	m_iTotalWDegree += pComplex->m_iTotalWDegree;
	m_iNumNodes += pComplex->m_iNumNodes;

	for(size_t i=0; i<pComplex->m_iNumNodes; ++i)
	{

		Node* pNode = m_pParent->m_NodeArray[pComplex->m_ComplexNodes[i]];
		Arc*  pArc  = pNode->m_pFirst;

		while(pArc!=NULL)
		{
			if(m_pParent->m_NodeArray[pArc->m_iNodeTo]->m_iComplex == m_iComplexNo)
			{
				m_iInDegree++;
				m_iInWDegree=m_iInWDegree+pArc->m_fOriginWeight;
			}

			pArc = pArc->m_pNextArc;
		}
	}


	for(size_t i=0; i<pComplex->m_iNumNodes; i++)
	{
		m_ComplexNodes.push_back(pComplex->m_ComplexNodes[i]);
		m_pParent->m_NodeArray[pComplex->m_ComplexNodes[i]]->m_iComplex = m_iComplexNo;
	}
	
	float fModule = 2*(float)m_iInWDegree/(float)(m_iTotalWDegree-2*m_iInWDegree);

	if(fModule>Complex::m_sThreshold)
	{
		m_bModule = true;
	}

}
void Clique::sortNodes()
{
	std::sort(m_CliqueNodes.begin(),m_CliqueNodes.end());
}
