#ifndef GRAPHLOADER_H
#define GRAPHLOADER_H
#include <vector>
#include <fstream>
#include <iostream>
#include <stdlib.h>

class GraphArc
{
public:
	char	m_szFrom[16];     //ʼ㵰
	char	m_szTo[16];		//յĵ
	float	m_fWeight;

public:
	GraphArc()
	{
		m_fWeight=1.0f;
	}

	GraphArc(char szFrom[16],char szTo[16],float fWeight)
	{
		strcpy(m_szFrom,szFrom);
		strcpy(m_szTo,szTo);
		m_fWeight=fWeight;
	}

};



class GraphLoader                    //ʼݵ
{
public:
	std::vector<GraphArc>	m_RawGraph;    //ʼıߵݱ
	int		m_nArcs;					   //ߵĸ
public:	
	GraphLoader()
	{
		m_nArcs=0;
	}

	GraphLoader(const char* szFileName)
	{
		LoadGraphFromFile(szFileName);
	}
	void LoadGraphFromFile(const char* szFileName)
	{
		m_RawGraph.clear();
		std::ifstream InFile(szFileName);
		if(!InFile)
		{
			std::cout<<"Can't Open The Input File!"<<std::endl;
			return ;
		}
		//InFile>>m_nArcs;
		GraphArc arc;
		for(;;)
		{
			if(!InFile)
				break;
			InFile>>arc.m_szFrom>>arc.m_szTo>>arc.m_fWeight;
			//arc.m_fWeight=0.0f;
			m_RawGraph.push_back(arc);
			InFile.ignore(100,'\n');
		}
		m_RawGraph.pop_back();
		InFile.close();
		m_nArcs=(int)m_RawGraph.size();
	}
};





#endif
