#include "Graph.h"
#include <string.h>
#include <time.h>


int main(int argc,char** argv)
{
	char inputFile[200];
	char outputFile[200];
	float fThreshold;
	int   iMinComplex;
	
	if(argc!=4)
	{
		printf("Command line parameter error!\n");
		printf("Usage: %s InputGraph fThreshold iMinComplex\n",argv[0]);
		exit(1);
	}
	
	strcpy(inputFile, argv[1]);
	strcpy(outputFile, inputFile);
	outputFile[strlen(outputFile)-4] = '\0';
	strcat(outputFile,"_Complex.txt");
	fThreshold = atof(argv[2]);
	iMinComplex = atoi(argv[3]);
	
	printf("Now generating Complex, please wait!\n");
	Graph graph(inputFile);	
	time_t	ts=clock();
	graph.GenerateComplexBy(fThreshold);

	graph.DumpComplexInfo(outputFile, iMinComplex);
	time_t  te=clock();
	printf("The Complex was generated,it was saved as \"%s\".\n",outputFile);
	std::cout<<"Used Time was: "<<te-ts<<" ms"<<std::endl;

	return 0;
}
